package tessile;

public class MaterialeArredamento extends Materiale{
	
	public static enum TipoArredamento{TENDAGGI, DIVANI, BIANCHERIA};
	private static final int METRATURA_MINIMA = 50;
	private static final int SCONTO_BASE = 15;
	private static final int SCONTO_AGGIUNTIVO = 10;
	
	private TipoArredamento tipoArredamento;
	
	public MaterialeArredamento(){
		this("",0,null); 
	}
	
	public MaterialeArredamento(String descrizione, double costo, TipoArredamento tipo){
		super(descrizione,costo);
		this.tipoArredamento = tipo;
	}
	
	// metodo polimorfo
	public double costoFornitura(int metri){
		double costo = getCostoAlMetro()*metri;
		int sconto;
		if(metri>METRATURA_MINIMA){
			sconto = SCONTO_BASE;
			if(tipoArredamento == TipoArredamento.BIANCHERIA)
				sconto += SCONTO_AGGIUNTIVO;
			// applicazione dello sconto
			costo *= (100 - sconto)/100;
		}
		return costo;
	}
	
	public TipoMateriale getTipoMateriale(){
		return TipoMateriale.ARREDAMENTO;
	}
	
	public TipoArredamento getTipoArredamento(){
		return tipoArredamento;
	}
	
	public String toString(){
		String s = super.toString();
		s += "Tipo arredamento: " + tipoArredamento + "\n";
		return s;
	}

}
