package tessile;

import java.util.*;
import tessile.MaterialeArredamento.TipoArredamento;
import tessile.Materiale.TipoMateriale;

public class TesterTessile {
	
	public static void main(String[] args){
		
		GestioneTessile gestioneTessile = new GestioneTessile();

		// punto a)
		DatiMateriali dati = gestioneTessile.contaMaterialiPerSettori();
		System.out.println(dati);
		
		// punto b)
		Materiale materiale = null;
		Scanner tastiera = new Scanner(System.in);
		boolean esistente;
		do{
			System.out.println("Inserire i dati del materiale: ");
			System.out.print("Descrizione: ");
			String descrizione = tastiera.nextLine();
			System.out.print("Costo al metro: ");
			double costo = tastiera.nextDouble();
			System.out.print("Tipo di materiale (abbigliamento, arredamento): ");
			String tipoMateriale = tastiera.next().toUpperCase();
			switch(TipoMateriale.valueOf(tipoMateriale)){
			case ABBIGLIAMENTO:
				System.out.print("Costo sartoria: ");
				double costoSartoria = tastiera.nextDouble();
				materiale = new MaterialeAbbigliamento(descrizione,costo,costoSartoria);
				break;
			case ARREDAMENTO:
				System.out.print("Tipo arredamento (tendaggi, divani, biancheria): ");
				String arredamento = tastiera.next().toUpperCase();
				TipoArredamento tipoArredamento = TipoArredamento.valueOf(arredamento);
				materiale = new MaterialeArredamento(descrizione,costo,tipoArredamento);
				break;
			default: 
			}
			esistente = gestioneTessile.aggiungiMateriale(materiale);
		}while(esistente);
		
		// punto c)
		System.out.print("Inserire la descrizione del materiale: ");
		// L'istruzione seguente viene introdotta per i motivi indicati nel commento
		tastiera.nextLine(); 
		/* lettura a vuoto per pulire il buffer in quanto se un 
		 * nextLine() e' preceduto da un next() o da un nextInt(), 
		 * nextDouble(),..., restituisce il newline che segue il 
		 * token acquisito. Tale newline non viene acquisito 
		 * insieme al token ma rimane nel buffer.
		 * Notare che diversi next() in sequenza non danno 
		 * problemi in quanto il next() incomincia ad acquisire 
		 * dal primo carattere utile, tralasciando quindi 
		 * eventuali newline che possono essere rimasti nel buffer */
		
		String descrizioneMateriale = tastiera.nextLine();
		System.out.print("Inserire il settore del materiale (abbigliamento, arredamento): ");
		String settore = tastiera.next().toUpperCase();
		TipoMateriale tipoSettore = TipoMateriale.valueOf(settore);
		gestioneTessile.fornitorePiuEconomico(descrizioneMateriale,tipoSettore);
		
		tastiera.close();
	}

}
